import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkCardDelLog, ThinkCardDelLogParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询注销卡日志
 */
export async function pageThinkCardDelLog(params: ThinkCardDelLogParam) {
  const res = await request.get<ApiResult<PageResult<ThinkCardDelLog>>>(
    THINK_API_URL + '/think/think-card-del-log/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询注销卡日志列表
 */
export async function listThinkCardDelLog(params?: ThinkCardDelLogParam) {
  const res = await request.get<ApiResult<ThinkCardDelLog[]>>(
    THINK_API_URL + '/think/think-card-del-log',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加注销卡日志
 */
export async function addThinkCardDelLog(data: ThinkCardDelLog) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-card-del-log',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改注销卡日志
 */
export async function updateThinkCardDelLog(data: ThinkCardDelLog) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-card-del-log',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除注销卡日志
 */
export async function removeThinkCardDelLog(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-card-del-log/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除注销卡日志
 */
export async function removeBatchThinkCardDelLog(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-card-del-log/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询注销卡日志
 */
export async function getThinkCardDelLog(id: number) {
  const res = await request.get<ApiResult<ThinkCardDelLog>>(
    THINK_API_URL + '/think/think-card-del-log/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
